;
;
; =============================================================================
;
;   DZ60_CE.asm		DEMO9S08DZ60 CE Test
;                                 
;   Version:		1.0   Created 12/04/05
;   Author:		Spencer Ruggles , Axiom Mfg.
;   Compiler:		CASMHCS08 / WinIDE2
;       
;   Platform:		DEMO9S08DZ, AXM-0407
;   Purpose:		Simple Demonstration Program
; =============================================================================
;
; Demo program for DEMO9S08DZ60 board. 

; ====================  EQUATES ===============================================

RAM:	equ $0080	; start of RAM
STACK:	equ $107F	; top of RAM + 1
FLASH:	equ $1400	; start of FLASH

PTB:    equ $0002       ; Port B
DDRB:   equ $0003       ; Data Dir PTB
PTC:    equ $0004       ; Port C
DDRC:   equ $0005       ; Data Dir PTC

SOPT1:	equ $1802	; System Option 1
SOPT2:	equ $1803	; System Option 2

; ====================  PROGRAM START  ========================================

	org FLASH		; place program in FLASH
;	org RAM			; place program in RAM

SETUP:
	sei			; mask interrupts	
	ldhx #STACK		; H:X points to SP
	txs			; init SP
	ldhx #SOPT1		; H:X points to SOPT1
	clra			; clear A
	sta ,X			; Disable COP
	mov #$08,PTB		; set PTB5
	mov #$20,PTC		; set PTC3
        mov #$08,DDRB           ; PTB[3] output 
        mov #$20,DDRC           ; PTC[5] output
	
MAIN:
	jsr LED1		; toggle LED1
	jsr DELAY		; wait
	jsr LED2		; toggle LED2
	jsr DELAY		; wait
	bra MAIN		; loop forever
	
; ===================== Sub-Routines ==========================================

DELAY:
	lda #$08		; outer loop delay count
DLY2:	ldhx #$ffff		; inner loop delay count
DLY1:	aix #-1			; decrement H:X 
	cphx #$0000		; update CCR
	bne DLY1		; inner loop
	sub #$01		; dec acc
	bne DLY2		; outer loop
	rts			; return

LED1:	ldhx #PTC		; PTC addr
	lda ,X			; read PTC
	eor #$20		; neg PTC[5]
	sta PTC			; write PTC
	rts			; return
		
LED2:	ldhx #PTB		; PTB addr
	lda ,X			; read PTC
	eor #$08		; neg PTB[3]
	sta PTB			; write PTB
	rts			; return
	

; ===================== Include Files =========================================

;	include 'c:\projects\lib\9s08\9S08SCI.inc'	; 9S08 SCI routines
;	include 'QG8Menu.asm'		; menu sub-routines
	
; ===================== Constants =============================================




; ===================== RESET VECTOR ==========================================

	org $FFFE
	DC.W SETUP	; Program Start


